transmogOutfitSelect = false
transmogOutfitSets = false
transmogOutfitPage = 1
transmogOutfitNumPages = 1
transmogOutfitCurrentOutfit = 1
transmogOutfitFoundOutfits = {}
transmogOutfitFoundBlizzardOutfits = 0

function transmogOutfitFrameOnEvent(self, event, arg1)
	if event == "ADDON_LOADED" and arg1 == "TransmogOutfits" then
		self:UnregisterEvent("ADDON_LOADED")
		if transmogOutfitOutfits == nil then
			transmogOutfitOutfits = {}
		end
	elseif event == "TRANSMOGRIFY_OPEN" then
		WardrobeOutfitDropDown:Hide()
		transmogOutfitFrameCreate(self)
	elseif event == "TRANSMOGRIFY_CLOSE" then
		transmogOutfitNewFrame:Hide()
		transmogOutfitSelectFrame:Hide()
		transmogOutfitRemoveFrame:Hide()
		transmogOutfitSelect = false
		transmogOutfitSets = false
		WardrobeCollectionFrameTab1:Show()
		WardrobeCollectionFrameTab2:Show()
	end
end

function transmogOutfitDropDownOnLoad()
	local renameOutfit = {}
	renameOutfit.text = "Rename"
	renameOutfit.value = 1
	renameOutfit.func = transmogOutfitDropDownOnClick
	local removeOutfit = {}
	removeOutfit.text = "Remove"
	removeOutfit.value = 2
	removeOutfit.func = transmogOutfitDropDownOnClick
	UIDropDownMenu_AddButton(renameOutfit)
	UIDropDownMenu_AddButton(removeOutfit)
end

function transmogOutfitDropDownOnClick(value)
	if value.value == 1 then
		transmogOutfitRenameFrame:Show()
	elseif value.value == 2 then
		TransmogOutfitRemoveOutfit()
	end
end

function transmogOutfitButtonOnClick(self)
	if self == transmogOutfitNewButton then
		transmogOutfitNewFrame:Show()
	elseif self == transmogOutfitSelectButton then
		if transmogOutfitSelect then
			if transmogOutfitSets then
				WardrobeCollectionFrame.SetsTransmogFrame:Show()
			else
				WardrobeCollectionFrame.ItemsCollectionFrame:Show()
			end
			WardrobeCollectionFrameTab1:Show()
			WardrobeCollectionFrameTab2:Show()
			WardrobeCollectionFrameSearchBox:Show()
			transmogOutfitSelectFrame:Hide()
			transmogOutfitSelect = false
		else
			transmogOutfitSets = WardrobeCollectionFrame.SetsTransmogFrame:IsVisible()
			WardrobeCollectionFrame.ItemsCollectionFrame:Hide()
			WardrobeCollectionFrame.SetsTransmogFrame:Hide()
			WardrobeCollectionFrameTab1:Hide()
			WardrobeCollectionFrameTab2:Hide()
			WardrobeCollectionFrameSearchBox:Hide()
			transmogOutfitSelectFrame:Show()
			transmogOutfitSelect = true
		end
	elseif self == transmogOutfitSaveButton then
		TransmogOutfitUpdateOutfit()
	elseif self == transmogOutfitRandomButton then
		TransmogOutfitRandomOutfit()
	elseif self == transmogOutfitNewDoneButton then
		TransmogOutfitNewOutfit()
	elseif self == transmogOutfitNewCancelButton then
		transmogOutfitNewFrame:Hide()
	elseif self == transmogOutfitSelectSearchButton then
		TransmogOutfitSearchOutfit()
	elseif self == transmogOutfitRemoveYesButton then
		TransmogOutfitRemoveYes()
	elseif self == transmogOutfitRemoveNoButton then
		transmogOutfitRemoveFrame:Hide()
	elseif self == transmogOutfitPrevPageButton then
		TransmogOutfitPrevPage()
	elseif self == transmogOutfitNextPageButton then
		TransmogOutfitNextPage()
	elseif self == transmogOutfitRenameDoneButton then
		TransmogOutfitRenameDone()
	elseif self == transmogOutfitRenameCancelButton then
		transmogOutfitRenameFrame:Hide()
	end
end

function TransmogOutfitFindBlizzardOutfit(name)
	local blizzardOutfits = C_TransmogCollection.GetOutfits()
	for i = 1, table.getn(blizzardOutfits) do
		if blizzardOutfits[i].name == name then
			return i
		end
	end
	return nil
end

function TransmogOutfitFindName(name)
	for i = 1, table.getn(transmogOutfitOutfits) do
		if transmogOutfitOutfits[i]["name"] == name then
			return i
		end
	end
	return nil
end

function TransmogOutfitUpdateOutfit()
	local name = transmogOutfitNameText:GetText()
	local blizzardOutfits = C_TransmogCollection.GetOutfits()
	local index = TransmogOutfitFindBlizzardOutfit(name)
	if index ~= nil then
		local outfit = {}
		outfit[1] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("HEADSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[3] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("SHOULDERSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[4] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("SHIRTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[5] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("CHESTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[6] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("WAISTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[7] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("LEGSSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[8] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("FEETSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[9] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("WRISTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[10] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("HANDSSLOT" ,Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[15] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("BACKSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[16] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("MAINHANDSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[17] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("SECONDARYHANDSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[19] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("TABARDSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		local enchant1 = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("MAINHANDSLOT", Enum.TransmogType.Illusion, Enum.TransmogModification.None))
		local enchant2 = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("SECONDARYHANDSLOT", Enum.TransmogType.Illusion, Enum.TransmogModification.None))
		local icon = select(4, C_TransmogCollection.GetAppearanceSourceInfo(outfit[1]));
		C_TransmogCollection.SaveOutfit(name, outfit, enchant1, enchant2, icon)
	else
		index = TransmogOutfitFindName(name)
		if index ~= nil then
			local outfit = {}
			outfit["name"] = name
			outfit[1] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("HEADSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
			outfit[3] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("SHOULDERSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
			outfit[4] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("SHIRTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
			outfit[5] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("CHESTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
			outfit[6] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("WAISTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
			outfit[7] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("LEGSSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
			outfit[8] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("FEETSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
			outfit[9] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("WRISTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
			outfit[10] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("HANDSSLOT" ,Enum.TransmogType.Appearance, Enum.TransmogModification.None))
			outfit[15] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("BACKSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
			outfit[16] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("MAINHANDSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
			outfit[17] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("SECONDARYHANDSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
			outfit[19] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("TABARDSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
			outfit["enchant1"] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("MAINHANDSLOT", Enum.TransmogType.Illusion, Enum.TransmogModification.None))
			outfit["enchant2"] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("SECONDARYHANDSLOT", Enum.TransmogType.Illusion, Enum.TransmogModification.None))
			transmogOutfitOutfits[index] = outfit
		end
	end
	if transmogOutfitSelectFrame:IsVisible() then
		transmogOutfitSelectFrame:Hide()
		transmogOutfitSelectFrame:Show()
	end
end

function TransmogOutfitNewOutfit()
	local name = transmogOutfitNewNameBox:GetText()
	local number = table.getn(transmogOutfitOutfits)
	transmogOutfitNewNameBox:SetText("")
	if name ~= "" and TransmogOutfitFindName(name) == nil then
		local outfit = {}
		transmogOutfitNameText:SetText(name)
		outfit["name"] = name
		outfit[1] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("HEADSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[3] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("SHOULDERSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[4] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("SHIRTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[5] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("CHESTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[6] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("WAISTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[7] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("LEGSSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[8] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("FEETSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[9] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("WRISTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[10] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("HANDSSLOT" ,Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[15] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("BACKSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[16] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("MAINHANDSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[17] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("SECONDARYHANDSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit[19] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("TABARDSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None))
		outfit["enchant1"] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("MAINHANDSLOT", Enum.TransmogType.Illusion, Enum.TransmogModification.None))
		outfit["enchant2"] = TransmogOutfitGetTransmog(TransmogUtil.GetTransmogLocation("SECONDARYHANDSLOT", Enum.TransmogType.Illusion, Enum.TransmogModification.None))
		transmogOutfitOutfits[number + 1] = outfit
		transmogOutfitNewFrame:Hide()
	end
	TransmogOutfitSearchOutfit()
end

function TransmogOutfitRandomOutfit()
	local blizzardOutfits = C_TransmogCollection.GetOutfits()
	local number = table.getn(blizzardOutfits) + table.getn(transmogOutfitOutfits)
	local rand = math.random(1, number)
	TransmogOutfitApplyOutfit(rand)
end

function TransmogOutfitSearchOutfit()
	local blizzardOutfits = C_TransmogCollection.GetOutfits()
	transmogOutfitFoundOutfits = {}
	if transmogOutfitSelectSearchBox:GetText() == "" then
		for i = 1, table.getn(blizzardOutfits) do
			transmogOutfitFoundOutfits[i] = i
		end
		transmogOutfitFoundBlizzardOutfits = table.getn(transmogOutfitFoundOutfits)
		for i = 1, table.getn(transmogOutfitOutfits) do
			transmogOutfitFoundOutfits[i + table.getn(blizzardOutfits)] = i + table.getn(blizzardOutfits)
		end
	else
		j = 0
		for i = 1, table.getn(blizzardOutfits) do
			if string.find(blizzardOutfits[i].name, transmogOutfitSelectSearchBox:GetText()) then
				transmogOutfitFoundOutfits[j] = i
				j = j + 1
			end
		end
		transmogOutfitFoundBlizzardOutfits = table.getn(transmogOutfitFoundOutfits)
		for i = 1, table.getn(transmogOutfitOutfits) do
			if string.find(transmogOutfitOutfits[i]["name"], transmogOutfitSelectSearchBox:GetText()) then
				transmogOutfitFoundOutfits[j] = i
				j = j + 1
			end
		end
	end
	if transmogOutfitSelectFrame:IsVisible() then
		transmogOutfitSelectFrame:Hide()
		transmogOutfitSelectFrame:Show()
	end
end

function TransmogOutfitSelectOutfit()
	local index = TransmogOutfitGetCheckedButton()
	TransmogOutfitApplyOutfit(index)
end

function TransmogOutfitApplyOutfit(index)
	local blizzardOutfits = C_TransmogCollection.GetOutfits()
	if blizzardOutfits[index] ~= nil then
		transmogOutfitNameText:SetText(blizzardOutfits[index].name)
		C_Transmog.LoadOutfit(blizzardOutfits[index].outfitID)
	else
		local outfit = transmogOutfitOutfits[index - transmogOutfitFoundBlizzardOutfits]
		if outfit ~= nil then
			transmogOutfitNameText:SetText(outfit["name"])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("HEADSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None), outfit[1])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("SHOULDERSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None), outfit[3])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("SHIRTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None), outfit[4])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("CHESTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None), outfit[5])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("WAISTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None), outfit[6])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("LEGSSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None), outfit[7])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("FEETSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None), outfit[8])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("WRISTSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None), outfit[9])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("HANDSSLOT" ,Enum.TransmogType.Appearance, Enum.TransmogModification.None), outfit[10])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("BACKSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None), outfit[15])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("MAINHANDSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None), outfit[16])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("SECONDARYHANDSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None), outfit[17])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("TABARDSLOT", Enum.TransmogType.Appearance, Enum.TransmogModification.None), outfit[19])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("MAINHANDSLOT", Enum.TransmogType.Illusion, Enum.TransmogModification.None), outfit["enchant1"])
			TransmogOutfitSetTransmog(TransmogUtil.GetTransmogLocation("SECONDARYHANDSLOT", Enum.TransmogType.Illusion, Enum.TransmogModification.None), outfit["enchant2"])
		end
	end
end

function TransmogOutfitRenameDone()
	if transmogOutfitRenameNameBox:GetText() ~= "" then
		local blizzardOutfits = C_TransmogCollection.GetOutfits()
		if transmogOutfitCurrentOutfit > transmogOutfitFoundBlizzardOutfits then
			if transmogOutfitNameText:GetText() == transmogOutfitOutfits[transmogOutfitCurrentOutfit - transmogOutfitFoundBlizzardOutfits]["name"] then
				transmogOutfitOutfits[transmogOutfitCurrentOutfit - transmogOutfitFoundBlizzardOutfits]["name"] = transmogOutfitRenameNameBox:GetText()
				transmogOutfitNameText:SetText(transmogOutfitRenameNameBox:GetText())
			else
				transmogOutfitOutfits[transmogOutfitCurrentOutfit - transmogOutfitFoundBlizzardOutfits]["name"] = transmogOutfitRenameNameBox:GetText()
			end
		else
			if transmogOutfitNameText:GetText() == blizzardOutfits[transmogOutfitCurrentOutfit].name then
				C_TransmogCollection.ModifyOutfit(blizzardOutfits[transmogOutfitCurrentOutfit].outfitID, transmogOutfitRenameNameBox:GetText())
				transmogOutfitNameText:SetText(transmogOutfitRenameNameBox:GetText())
			else
				C_TransmogCollection.ModifyOutfit(blizzardOutfits[transmogOutfitCurrentOutfit].outfitID, transmogOutfitRenameNameBox:GetText())
			end
		end
		TransmogOutfitSearchOutfit()
		transmogOutfitRenameFrame:Hide()
	end
end

function TransmogOutfitRemoveOutfit()
	local blizzardOutfits = C_TransmogCollection.GetOutfits()
	local name
	if transmogOutfitCurrentOutfit > transmogOutfitFoundBlizzardOutfits then
		name = transmogOutfitOutfits[transmogOutfitCurrentOutfit - transmogOutfitFoundBlizzardOutfits]["name"]
	else 
		name = blizzardOutfits[transmogOutfitCurrentOutfit].name
	end
	transmogOutfitRemoveFrame:Show()
	transmogOutfitRemoveText:SetText("\n\nDo realy want to remove outfit\nnamed " .. name .. "?")
end

function TransmogOutfitRemoveYes()
	local blizzardOutfits = C_TransmogCollection.GetOutfits()
	if transmogOutfitCurrentOutfit > transmogOutfitFoundBlizzardOutfits then
		if transmogOutfitNameText:GetText() == transmogOutfitOutfits[transmogOutfitCurrentOutfit - transmogOutfitFoundBlizzardOutfits]["name"] then
			transmogOutfitNameText:SetText("No Outfit")
		end
	elseif transmogOutfitNameText:GetText() == blizzardOutfits[transmogOutfitCurrentOutfit].name then
		transmogOutfitNameText:SetText("No Outfit")
	end
	if blizzardOutfits[transmogOutfitCurrentOutfit] ~= nil then
		C_TransmogCollection.DeleteOutfit(blizzardOutfits[transmogOutfitCurrentOutfit].outfitID)
	else
		table.remove(transmogOutfitOutfits, transmogOutfitCurrentOutfit - transmogOutfitFoundBlizzardOutfits)
	end
	TransmogOutfitSearchOutfit()
	transmogOutfitRemoveFrame:Hide()
end

function TransmogOutfitGetTransmog(slot)
	local transmog
	local baseSourceID, _, appliedSourceID, _, _, pendingSourceID, _, _, hasPendingUndo = C_Transmog.GetSlotVisualInfo(slot)
	if hasPendingUndo then
		transmog = baseSourceID
	elseif pendingSourceID ~= 0 then
		transmog = pendingSourceID
	elseif appliedSourceID ~= 0 then
		transmog = appliedSourceID
	else
		transmog = baseSourceID
	end
	return transmog
end

function TransmogOutfitSetTransmog(slot, transmog)
	C_Transmog.ClearPending(slot)
	local _, _, _, canTransmogrify = C_Transmog.GetSlotInfo(slot)
	if canTransmogrify then
		C_Transmog.SetPending(slot, transmog)
	end
end

function transmogOutfitSelectFrameOnShow(self)
	local blizzardOutfits = C_TransmogCollection.GetOutfits()
	transmogOutfitNumPages = math.ceil(table.getn(transmogOutfitFoundOutfits) / 8)
	if transmogOutfitPage > transmogOutfitNumPages then
		transmogOutfitPage = transmogOutfitNumPages
	end
	transmogOutfitPagesText:SetText("Page " .. transmogOutfitPage .. "/" .. transmogOutfitNumPages)
	for i = 1, 8 do
		transmogOutfitModels[i]:Show()
		if blizzardOutfits[transmogOutfitFoundOutfits[i + 8 * (transmogOutfitPage - 1)]] ~= nil then
			local sources  = C_TransmogCollection.GetOutfitSources(blizzardOutfits[transmogOutfitFoundOutfits[i + 8 * (transmogOutfitPage - 1)]].outfitID)
			transmogOutfitModels[i]:TryOn(sources[1])
			transmogOutfitModels[i]:TryOn(sources[3])
			transmogOutfitModels[i]:TryOn(sources[4])
			transmogOutfitModels[i]:TryOn(sources[5])
			transmogOutfitModels[i]:TryOn(sources[6])
			transmogOutfitModels[i]:TryOn(sources[7])
			transmogOutfitModels[i]:TryOn(sources[8])
			transmogOutfitModels[i]:TryOn(sources[9])
			transmogOutfitModels[i]:TryOn(sources[10])
			transmogOutfitModels[i]:TryOn(sources[15])
			transmogOutfitModels[i]:TryOn(sources[16])
			transmogOutfitModels[i]:TryOn(sources[17])
			transmogOutfitModels[i]:TryOn(sources[19])
			transmogOutfitModels[i]:TryOn(enchant1)
			transmogOutfitModels[i]:TryOn(enchant2)
			transmogOutfitModelTexts[i]:SetText(blizzardOutfits[transmogOutfitFoundOutfits[i + 8 * (transmogOutfitPage - 1)]].name)
		elseif transmogOutfitOutfits[transmogOutfitFoundOutfits[i + 8 * (transmogOutfitPage - 1) - transmogOutfitFoundBlizzardOutfits]] then
			local sources = transmogOutfitOutfits[transmogOutfitFoundOutfits[i + 8 * (transmogOutfitPage - 1) - transmogOutfitFoundBlizzardOutfits]]
			transmogOutfitModels[i]:TryOn(sources[1])
			transmogOutfitModels[i]:TryOn(sources[3])
			transmogOutfitModels[i]:TryOn(sources[4])
			transmogOutfitModels[i]:TryOn(sources[5])
			transmogOutfitModels[i]:TryOn(sources[6])
			transmogOutfitModels[i]:TryOn(sources[7])
			transmogOutfitModels[i]:TryOn(sources[8])
			transmogOutfitModels[i]:TryOn(sources[9])
			transmogOutfitModels[i]:TryOn(sources[10])
			transmogOutfitModels[i]:TryOn(sources[15])
			transmogOutfitModels[i]:TryOn(sources[16])
			transmogOutfitModels[i]:TryOn(sources[17])
			transmogOutfitModels[i]:TryOn(sources[19])
			transmogOutfitModelTexts[i]:SetText(sources["name"])
		else
			transmogOutfitModels[i]:Hide()
		end
	end
end

function TransmogOutfitPrevPage()
	if transmogOutfitPage > 1 then
		transmogOutfitPage = transmogOutfitPage - 1
		transmogOutfitSelectFrame:Hide()
		transmogOutfitSelectFrame:Show()
	else
		transmogOutfitPage = transmogOutfitPage
	end
end

function TransmogOutfitNextPage()
	if transmogOutfitPage < transmogOutfitNumPages then
		transmogOutfitPage =transmogOutfitPage + 1
		transmogOutfitSelectFrame:Hide()
		transmogOutfitSelectFrame:Show()
	else
		transmogOutfitPage = transmogOutfitPage
	end
end
	
function transmogOutfitFrameCreate(frame)
	if WardrobeTransmogFrame:IsVisible() then
		transmogOutfitFoundOutfits = {}
		local blizzardOutfits = C_TransmogCollection.GetOutfits()
		for i = 1, table.getn(blizzardOutfits) do
			transmogOutfitFoundOutfits[i] = i
		end
		transmogOutfitFoundBlizzardOutfits = table.getn(transmogOutfitFoundOutfits)
		for i = 1, table.getn(transmogOutfitOutfits) do
			transmogOutfitFoundOutfits[i + table.getn(blizzardOutfits)] = i + table.getn(blizzardOutfits)
		end
		frame:SetFrameStrata("TOOLTIP")
		frame:SetWidth(WardrobeTransmogFrame:GetWidth()) 
		frame:SetHeight(50)
		frame:ClearAllPoints()
		frame:SetPoint("BOTTOMRIGHT", WardrobeTransmogFrame, "TOPRIGHT", 0, 0)
		frame:SetParent(WardrobeTransmogFrame)
		frame:Show()
		TransmogOutfitSetupNameFrame(transmogOutfitNameFrame, transmogOutfitNameText)
		transmogOutfitSelectFrame = CreateFrame("FRAME", nil, WardrobeCollectionFrame, "CollectionsBackgroundTemplate")
		transmogOutfitSelectFrame:SetScript("OnShow", transmogOutfitSelectFrameOnShow)
		transmogOutfitSelectFrame:Hide()
		ModelFrames(transmogOutfitSelectFrame)
		transmogOutfitRandomButton = CreateFrame("BUTTON", nil, transmogOutfitSelectFrame, "UIPanelButtonTemplate")
		TransmogOutfitSetupButton(transmogOutfitRandomButton, "Select Random", 100)
		transmogOutfitRandomButton:SetPoint("TOPRIGHT", transmogOutfitSelectFrame, "TOPRIGHT")
		transmogOutfitSelectSearchBox = CreateFrame("EDITBOX", nil, transmogOutfitSelectFrame, "InputBoxTemplate")
		TransmogOutfitSetupEditBox(transmogOutfitSelectSearchBox, 120)
		transmogOutfitSelectSearchBox:SetAutoFocus(false)
		transmogOutfitSelectSearchBox:SetPoint("BOTTOMRIGHT", transmogOutfitSelectFrame, "TOPRIGHT", -100, 0)
		transmogOutfitSelectSearchButton = CreateFrame("BUTTON", nil, transmogOutfitSelectFrame, "UIPanelButtonTemplate")
		TransmogOutfitSetupButton(transmogOutfitSelectSearchButton, "Search", 100)
		transmogOutfitSelectSearchButton:SetFrameStrata("TOOLTIP")
		transmogOutfitSelectSearchButton:SetPoint("BOTTOMRIGHT", transmogOutfitSelectFrame, "TOPRIGHT", 0, 0)
		transmogOutfitPages = CreateFrame("FRAME", nil, transmogOutfitSelectFrame, nil)
		transmogOutfitPages:SetPoint("BOTTOM", transmogOutfitSelectFrame, "BOTTOM", 0, 20)
		transmogOutfitPages:SetFrameStrata("TOOLTIP")
		transmogOutfitPages:SetWidth(150)
		transmogOutfitPages:SetHeight(50)
		transmogOutfitPagesText = transmogOutfitPages:CreateFontString(nil, "OVERLAY", "GameFontWhite")
		transmogOutfitPagesText:ClearAllPoints()
		transmogOutfitPagesText:SetAllPoints(transmogOutfitPages) 
		transmogOutfitPagesText:SetJustifyH("CENTER")
		transmogOutfitPagesText:SetJustifyV("CENTER")
		transmogOutfitPrevPageButton = CreateFrame("BUTTON", nil, transmogOutfitPages, "UIPanelButtonTemplate")
		TransmogOutfitSetupButton(transmogOutfitPrevPageButton, "<", 25)
		transmogOutfitPrevPageButton:SetPoint("LEFT", transmogOutfitPages, "LEFT", 0, 0)
		transmogOutfitNextPageButton = CreateFrame("BUTTON", nil, transmogOutfitPages, "UIPanelButtonTemplate")
		TransmogOutfitSetupButton(transmogOutfitNextPageButton, ">", 25)
		transmogOutfitNextPageButton:SetPoint("RIGHT", transmogOutfitPages, "RIGHT", 0, 0)
	end
end

function ModelFrames(parent)
	transmogOutfitModels = {}
	transmogOutfitModelTexts = {}
	transmogOutfitModels[1] = CreateFrame("DressUpModel", "1", parent, BackdropTemplateMixin and "BackdropTemplate")
	transmogOutfitModelTexts[1] = transmogOutfitModels[1]:CreateFontString(nil, "OVERLAY", "GameFontWhite")
	SetupModelFrame(transmogOutfitModels[1], transmogOutfitModelTexts[1], -225, 100)
	transmogOutfitModels[2] = CreateFrame("DressUpModel", "2", parent, BackdropTemplateMixin and "BackdropTemplate")
	transmogOutfitModelTexts[2] = transmogOutfitModels[2]:CreateFontString(nil, "OVERLAY", "GameFontWhite")
	SetupModelFrame(transmogOutfitModels[2], transmogOutfitModelTexts[2], -75, 100)
	transmogOutfitModels[3] = CreateFrame("DressUpModel", "3", parent, BackdropTemplateMixin and "BackdropTemplate")
	transmogOutfitModelTexts[3] = transmogOutfitModels[3]:CreateFontString(nil, "OVERLAY", "GameFontWhite")
	SetupModelFrame(transmogOutfitModels[3], transmogOutfitModelTexts[3], 75, 100)
	transmogOutfitModels[4] = CreateFrame("DressUpModel", "4", parent, BackdropTemplateMixin and "BackdropTemplate")
	transmogOutfitModelTexts[4] = transmogOutfitModels[4]:CreateFontString(nil, "OVERLAY", "GameFontWhite")
	SetupModelFrame(transmogOutfitModels[4], transmogOutfitModelTexts[4], 225, 100)
	transmogOutfitModels[5] = CreateFrame("DressUpModel", "5", parent, BackdropTemplateMixin and "BackdropTemplate")
	transmogOutfitModelTexts[5] = transmogOutfitModels[5]:CreateFontString(nil, "OVERLAY", "GameFontWhite")
	SetupModelFrame(transmogOutfitModels[5], transmogOutfitModelTexts[5], -225, -100)
	transmogOutfitModels[6] = CreateFrame("DressUpModel", "6", parent, BackdropTemplateMixin and "BackdropTemplate")
	transmogOutfitModelTexts[6] = transmogOutfitModels[6]:CreateFontString(nil, "OVERLAY", "GameFontWhite")
	SetupModelFrame(transmogOutfitModels[6], transmogOutfitModelTexts[6], -75, -100)
	transmogOutfitModels[7] = CreateFrame("DressUpModel", "7", parent, BackdropTemplateMixin and "BackdropTemplate")
	transmogOutfitModelTexts[7] = transmogOutfitModels[7]:CreateFontString(nil, "OVERLAY", "GameFontWhite")
	SetupModelFrame(transmogOutfitModels[7], transmogOutfitModelTexts[7], 75, -100)
	transmogOutfitModels[8] = CreateFrame("DressUpModel", "8", parent, BackdropTemplateMixin and "BackdropTemplate")
	transmogOutfitModelTexts[8] = transmogOutfitModels[8]:CreateFontString(nil, "OVERLAY", "GameFontWhite")
	SetupModelFrame(transmogOutfitModels[8], transmogOutfitModelTexts[8], 225, -100)
end

function transmogOutfitModelFrameOnClick(self, button, down)
	local index = transmogOutfitFoundOutfits[tonumber(self:GetName()) + 8 * (transmogOutfitPage - 1)]
	if button == "LeftButton" then
		TransmogOutfitApplyOutfit(index)
	elseif button == "RightButton" then
	transmogOutfitCurrentOutfit = index
		ToggleDropDownMenu(1, nil, transmogOutfitDropDown, self, 0, 200)
	end
end

function SetupModelFrame(frame, text, x, y)
	frame:SetWidth(150)
	frame:SetHeight(200)
	frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
					   edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
					   tile = true,
					   tileSize = 16,
					   edgeSize = 16, 
					   insets = {left = 1,
								 right = 1,
								 top = 1,
								 bottom = 1}}) 
	frame:SetBackdropColor(0, 0, 0, 1)
	frame:Show()
	frame:SetUnit("player")
	frame:SetCustomCamera(1)
	frame:SetPoint("CENTER", transmogOutfitSelectFrame, "CENTER", x, y)
	frame:FreezeAnimation(0)
	frame:EnableMouse(true)
	frame:SetScript("OnMouseDown", transmogOutfitModelFrameOnClick)
	text:ClearAllPoints()
	text:SetPoint("BOTTOM", frame, "BOTTOM", 0, 10)
	text:SetJustifyH("CENTER")
	text:SetJustifyV("CENTER")
end

function TransmogOutfitSetupNameFrame(frame, text)
	frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
					   edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
					   tile = true,
					   tileSize = 16,
					   edgeSize = 16, 
					   insets = {left = 1,
								 right = 1,
								 top = 1,
								 bottom = 1}}) 
	frame:SetBackdropColor(0, 0, 0, 1)
	frame:SetWidth(WardrobeTransmogFrame:GetWidth() - 100) 
	frame:SetHeight(25)
	text:ClearAllPoints()
	text:SetAllPoints(frame) 
	text:SetJustifyH("CENTER")
	text:SetJustifyV("CENTER")
	text:SetText("No Outfit")
	frame:Show()
end

function TransmogOutfitSetupButton(button, text, width)
	button:SetText(text)
	button:SetHeight(25)
	button:SetWidth(width)
	button:ClearAllPoints()
	button:SetScript("OnClick", transmogOutfitButtonOnClick)
	button:Show()
end

function TransmogOutfitSetupPopupFrame(frame, width, height)
	frame:SetBackdrop({bgFile = "Interface\PaperDollInfoFrame\UI-Character-Tab-Highlight-yellow", 
					   edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
					   tile = true,
					   tileSize = 16,
					   edgeSize = 16, 
					   insets = {left = 1,
								 right = 1,
								 top = 1,
								 bottom = 1}}) 
	frame:SetFrameStrata("TOOLTIP")
	frame:SetBackdropColor(0, 0, 0, 1)
	frame:SetWidth(width) 
	frame:SetHeight(height) 
	frame:Hide()
end

function TransmogOutfitSetupEditBox(editBox, width)
	editBox:SetWidth(width)
	editBox:SetHeight(25)
	editBox:ClearAllPoints()
	editBox:Show()
end

local transmogOutfitFrame = CreateFrame("FRAME", nil, UIParent)
transmogOutfitFrame:RegisterEvent("ADDON_LOADED")
transmogOutfitFrame:RegisterEvent("TRANSMOGRIFY_OPEN")
transmogOutfitFrame:RegisterEvent("TRANSMOGRIFY_CLOSE")
transmogOutfitFrame:SetScript("OnEvent", transmogOutfitFrameOnEvent)
transmogOutfitNameFrame = CreateFrame("FRAME", nil, transmogOutfitFrame, BackdropTemplateMixin and "BackdropTemplate")
transmogOutfitNameText = transmogOutfitNameFrame:CreateFontString(nil, "OVERLAY", "GameFontWhite")
transmogOutfitNameFrame:SetPoint("TOP", transmogOutfitFrame, "TOP")
transmogOutfitNewButton = CreateFrame("BUTTON", nil, transmogOutfitFrame, "UIPanelButtonTemplate")
TransmogOutfitSetupButton(transmogOutfitNewButton, "Save New", 100)
transmogOutfitNewButton:SetPoint("BOTTOMLEFT", transmogOutfitFrame, "BOTTOMLEFT")
transmogOutfitSelectButton = CreateFrame("BUTTON", nil, transmogOutfitFrame, "UIPanelButtonTemplate")
TransmogOutfitSetupButton(transmogOutfitSelectButton, "Select Outfit", 100)
transmogOutfitSelectButton:SetPoint("BOTTOM", transmogOutfitFrame, "BOTTOM")
transmogOutfitSaveButton = CreateFrame("BUTTON", nil, transmogOutfitFrame, "UIPanelButtonTemplate")
TransmogOutfitSetupButton(transmogOutfitSaveButton, "Save Current", 100)
transmogOutfitSaveButton:SetPoint("BOTTOMRIGHT", transmogOutfitFrame, "BOTTOMRIGHT")

transmogOutfitNewFrame = CreateFrame("FRAME", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
TransmogOutfitSetupPopupFrame(transmogOutfitNewFrame, 250, 100)
transmogOutfitNewFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
transmogOutfitNewNameBox = CreateFrame("EDITBOX", nil, transmogOutfitNewFrame, "InputBoxTemplate")
TransmogOutfitSetupEditBox(transmogOutfitNewNameBox, 200)
transmogOutfitNewNameBox:SetPoint("CENTER", transmogOutfitNewFrame, "CENTER", 0, 25)
transmogOutfitNewDoneButton = CreateFrame("BUTTON", nil, transmogOutfitNewFrame, "UIPanelButtonTemplate")
TransmogOutfitSetupButton(transmogOutfitNewDoneButton, "Done", 100)
transmogOutfitNewDoneButton:SetPoint("CENTER", transmogOutfitNewFrame, "CENTER", -50, -25)
transmogOutfitNewCancelButton = CreateFrame("BUTTON", nil, transmogOutfitNewFrame, "UIPanelButtonTemplate")
TransmogOutfitSetupButton(transmogOutfitNewCancelButton, "Cancel", 100)
transmogOutfitNewCancelButton:SetPoint("CENTER", transmogOutfitNewFrame, "CENTER", 50, -25)

transmogOutfitRemoveFrame = CreateFrame("FRAME", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate") 
TransmogOutfitSetupPopupFrame(transmogOutfitRemoveFrame, 250, 100)
transmogOutfitRemoveFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
transmogOutfitRemoveText = transmogOutfitRemoveFrame:CreateFontString(nil, "OVERLAY", "GameFontWhite")
transmogOutfitRemoveText:ClearAllPoints()
transmogOutfitRemoveText:SetAllPoints(transmogOutfitRemoveFrame) 
transmogOutfitRemoveText:SetJustifyH("CENTER")
transmogOutfitRemoveText:SetJustifyV("TOP")
transmogOutfitRemoveYesButton = CreateFrame("BUTTON", nil, transmogOutfitRemoveFrame, "UIPanelButtonTemplate")
TransmogOutfitSetupButton(transmogOutfitRemoveYesButton, "Yes", 100)
transmogOutfitRemoveYesButton:SetPoint("CENTER", transmogOutfitRemoveFrame, "CENTER", -55, -25)
transmogOutfitRemoveNoButton = CreateFrame("BUTTON", nil, transmogOutfitRemoveFrame, "UIPanelButtonTemplate")
TransmogOutfitSetupButton(transmogOutfitRemoveNoButton, "No", 100)
transmogOutfitRemoveNoButton:SetPoint("CENTER", transmogOutfitRemoveFrame, "CENTER", 55, -25)

transmogOutfitRenameFrame = CreateFrame("FRAME", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
TransmogOutfitSetupPopupFrame(transmogOutfitRenameFrame, 250, 100)
transmogOutfitRenameFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
transmogOutfitRenameNameBox = CreateFrame("EDITBOX", nil, transmogOutfitRenameFrame, "InputBoxTemplate")
TransmogOutfitSetupEditBox(transmogOutfitRenameNameBox, 200)
transmogOutfitRenameNameBox:SetPoint("CENTER", transmogOutfitRenameFrame, "CENTER", 0, 25)
transmogOutfitRenameDoneButton = CreateFrame("BUTTON", nil, transmogOutfitRenameFrame, "UIPanelButtonTemplate")
TransmogOutfitSetupButton(transmogOutfitRenameDoneButton, "Done", 100)
transmogOutfitRenameDoneButton:SetPoint("CENTER", transmogOutfitRenameFrame, "CENTER", -50, -25)
transmogOutfitRenameCancelButton = CreateFrame("BUTTON", nil, transmogOutfitRenameFrame, "UIPanelButtonTemplate")
TransmogOutfitSetupButton(transmogOutfitRenameCancelButton, "Cancel", 100)
transmogOutfitRenameCancelButton:SetPoint("CENTER", transmogOutfitRenameFrame, "CENTER", 50, -25)

transmogOutfitDropDown = CreateFrame("FRAME", "GarrisonReportDropDown", UIParent, "UIDropDownMenuTemplate")
UIDropDownMenu_Initialize(transmogOutfitDropDown, transmogOutfitDropDownOnLoad, "MENU")